pragma Warnings (Off);
pragma Ada_95;
pragma Source_File_Name (zlib_adamain, Spec_File_Name => "b__zlib_ada.ads");
pragma Source_File_Name (zlib_adamain, Body_File_Name => "b__zlib_ada.adb");
pragma Suppress (Overflow_Check);
with Ada.Exceptions;

package body zlib_adamain is

   E13 : Short_Integer; pragma Import (Ada, E13, "ada__exceptions_E");
   E18 : Short_Integer; pragma Import (Ada, E18, "system__soft_links_E");
   E30 : Short_Integer; pragma Import (Ada, E30, "system__exception_table_E");
   E32 : Short_Integer; pragma Import (Ada, E32, "system__exceptions_E");
   E26 : Short_Integer; pragma Import (Ada, E26, "system__soft_links__initialize_E");
   E78 : Short_Integer; pragma Import (Ada, E78, "ada__io_exceptions_E");
   E89 : Short_Integer; pragma Import (Ada, E89, "interfaces__c_E");
   E91 : Short_Integer; pragma Import (Ada, E91, "interfaces__c__strings_E");
   E11 : Short_Integer; pragma Import (Ada, E11, "ada__tags_E");
   E77 : Short_Integer; pragma Import (Ada, E77, "ada__streams_E");
   E80 : Short_Integer; pragma Import (Ada, E80, "system__finalization_root_E");
   E75 : Short_Integer; pragma Import (Ada, E75, "ada__finalization_E");
   E82 : Short_Integer; pragma Import (Ada, E82, "system__storage_pools_E");
   E70 : Short_Integer; pragma Import (Ada, E70, "system__finalization_masters_E");
   E84 : Short_Integer; pragma Import (Ada, E84, "system__pool_global_E");
   E06 : Short_Integer; pragma Import (Ada, E06, "zlib_E");
   E04 : Short_Integer; pragma Import (Ada, E04, "zlib__thin_E");
   E02 : Short_Integer; pragma Import (Ada, E02, "zlib__streams_E");

   Sec_Default_Sized_Stacks : array (1 .. 1) of aliased System.Secondary_Stack.SS_Stack (System.Parameters.Runtime_Default_Sec_Stack_Size);

   Local_Priority_Specific_Dispatching : constant String := "";
   Local_Interrupt_States : constant String := "";

   Is_Elaborated : Boolean := False;

   procedure finalize_library is
   begin
      E02 := E02 - 1;
      declare
         procedure F1;
         pragma Import (Ada, F1, "zlib__streams__finalize_spec");
      begin
         if E02 = 0 then
            F1;
         end if;
      end;
      E06 := E06 - 1;
      declare
         procedure F2;
         pragma Import (Ada, F2, "zlib__finalize_spec");
      begin
         if E06 = 0 then
            F2;
         end if;
      end;
      E84 := E84 - 1;
      declare
         procedure F3;
         pragma Import (Ada, F3, "system__pool_global__finalize_spec");
      begin
         if E84 = 0 then
            F3;
         end if;
      end;
      E70 := E70 - 1;
      declare
         procedure F4;
         pragma Import (Ada, F4, "system__finalization_masters__finalize_spec");
      begin
         if E70 = 0 then
            F4;
         end if;
      end;
      declare
         procedure Reraise_Library_Exception_If_Any;
            pragma Import (Ada, Reraise_Library_Exception_If_Any, "__gnat_reraise_library_exception_if_any");
      begin
         Reraise_Library_Exception_If_Any;
      end;
   end finalize_library;

   procedure zlib_adafinal is

      procedure Runtime_Finalize;
      pragma Import (C, Runtime_Finalize, "__gnat_runtime_finalize");

   begin
      if not Is_Elaborated then
         return;
      end if;
      Is_Elaborated := False;
      Runtime_Finalize;
      finalize_library;
   end zlib_adafinal;

   type No_Param_Proc is access procedure;
   pragma Favor_Top_Level (No_Param_Proc);

   procedure zlib_adainit is
      Main_Priority : Integer;
      pragma Import (C, Main_Priority, "__gl_main_priority");
      Time_Slice_Value : Integer;
      pragma Import (C, Time_Slice_Value, "__gl_time_slice_val");
      WC_Encoding : Character;
      pragma Import (C, WC_Encoding, "__gl_wc_encoding");
      Locking_Policy : Character;
      pragma Import (C, Locking_Policy, "__gl_locking_policy");
      Queuing_Policy : Character;
      pragma Import (C, Queuing_Policy, "__gl_queuing_policy");
      Task_Dispatching_Policy : Character;
      pragma Import (C, Task_Dispatching_Policy, "__gl_task_dispatching_policy");
      Priority_Specific_Dispatching : System.Address;
      pragma Import (C, Priority_Specific_Dispatching, "__gl_priority_specific_dispatching");
      Num_Specific_Dispatching : Integer;
      pragma Import (C, Num_Specific_Dispatching, "__gl_num_specific_dispatching");
      Main_CPU : Integer;
      pragma Import (C, Main_CPU, "__gl_main_cpu");
      Interrupt_States : System.Address;
      pragma Import (C, Interrupt_States, "__gl_interrupt_states");
      Num_Interrupt_States : Integer;
      pragma Import (C, Num_Interrupt_States, "__gl_num_interrupt_states");
      Unreserve_All_Interrupts : Integer;
      pragma Import (C, Unreserve_All_Interrupts, "__gl_unreserve_all_interrupts");
      Detect_Blocking : Integer;
      pragma Import (C, Detect_Blocking, "__gl_detect_blocking");
      Default_Stack_Size : Integer;
      pragma Import (C, Default_Stack_Size, "__gl_default_stack_size");
      Default_Secondary_Stack_Size : System.Parameters.Size_Type;
      pragma Import (C, Default_Secondary_Stack_Size, "__gnat_default_ss_size");
      Leap_Seconds_Support : Integer;
      pragma Import (C, Leap_Seconds_Support, "__gl_leap_seconds_support");
      Bind_Env_Addr : System.Address;
      pragma Import (C, Bind_Env_Addr, "__gl_bind_env_addr");

      procedure Runtime_Initialize (Install_Handler : Integer);
      pragma Import (C, Runtime_Initialize, "__gnat_runtime_initialize");

      Finalize_Library_Objects : No_Param_Proc;
      pragma Import (C, Finalize_Library_Objects, "__gnat_finalize_library_objects");
      Binder_Sec_Stacks_Count : Natural;
      pragma Import (Ada, Binder_Sec_Stacks_Count, "__gnat_binder_ss_count");
      Default_Sized_SS_Pool : System.Address;
      pragma Import (Ada, Default_Sized_SS_Pool, "__gnat_default_ss_pool");

   begin
      if Is_Elaborated then
         return;
      end if;
      Is_Elaborated := True;
      Main_Priority := -1;
      Time_Slice_Value := -1;
      WC_Encoding := 'b';
      Locking_Policy := ' ';
      Queuing_Policy := ' ';
      Task_Dispatching_Policy := ' ';
      Priority_Specific_Dispatching :=
        Local_Priority_Specific_Dispatching'Address;
      Num_Specific_Dispatching := 0;
      Main_CPU := -1;
      Interrupt_States := Local_Interrupt_States'Address;
      Num_Interrupt_States := 0;
      Unreserve_All_Interrupts := 0;
      Detect_Blocking := 0;
      Default_Stack_Size := -1;
      Leap_Seconds_Support := 0;

      zlib_adamain'Elab_Body;
      Default_Secondary_Stack_Size := System.Parameters.Runtime_Default_Sec_Stack_Size;
      Binder_Sec_Stacks_Count := 1;
      Default_Sized_SS_Pool := Sec_Default_Sized_Stacks'Address;

      Runtime_Initialize (1);

      if E13 = 0 then
         Ada.Exceptions'Elab_Spec;
      end if;
      if E18 = 0 then
         System.Soft_Links'Elab_Spec;
      end if;
      if E30 = 0 then
         System.Exception_Table'Elab_Body;
      end if;
      E30 := E30 + 1;
      if E32 = 0 then
         System.Exceptions'Elab_Spec;
      end if;
      E32 := E32 + 1;
      if E26 = 0 then
         System.Soft_Links.Initialize'Elab_Body;
      end if;
      E26 := E26 + 1;
      E18 := E18 + 1;
      E13 := E13 + 1;
      if E78 = 0 then
         Ada.Io_Exceptions'Elab_Spec;
      end if;
      E78 := E78 + 1;
      if E89 = 0 then
         Interfaces.C'Elab_Spec;
      end if;
      E89 := E89 + 1;
      if E91 = 0 then
         Interfaces.C.Strings'Elab_Spec;
      end if;
      E91 := E91 + 1;
      if E11 = 0 then
         Ada.Tags'Elab_Spec;
      end if;
      if E11 = 0 then
         Ada.Tags'Elab_Body;
      end if;
      E11 := E11 + 1;
      if E77 = 0 then
         Ada.Streams'Elab_Spec;
      end if;
      E77 := E77 + 1;
      if E80 = 0 then
         System.Finalization_Root'Elab_Spec;
      end if;
      E80 := E80 + 1;
      if E75 = 0 then
         Ada.Finalization'Elab_Spec;
      end if;
      E75 := E75 + 1;
      if E82 = 0 then
         System.Storage_Pools'Elab_Spec;
      end if;
      E82 := E82 + 1;
      if E70 = 0 then
         System.Finalization_Masters'Elab_Spec;
      end if;
      if E70 = 0 then
         System.Finalization_Masters'Elab_Body;
      end if;
      E70 := E70 + 1;
      if E84 = 0 then
         System.Pool_Global'Elab_Spec;
      end if;
      E84 := E84 + 1;
      if E06 = 0 then
         Zlib'Elab_Spec;
      end if;
      if E04 = 0 then
         Zlib.Thin'Elab_Body;
      end if;
      E04 := E04 + 1;
      if E06 = 0 then
         Zlib'Elab_Body;
      end if;
      E06 := E06 + 1;
      if E02 = 0 then
         Zlib.Streams'Elab_Spec;
      end if;
      if E02 = 0 then
         Zlib.Streams'Elab_Body;
      end if;
      E02 := E02 + 1;
   end zlib_adainit;

--  BEGIN Object file/option list
   --   /builddir/build/BUILD/zlib-ada/zlib-thin.o
   --   /builddir/build/BUILD/zlib-ada/zlib.o
   --   /builddir/build/BUILD/zlib-ada/zlib-streams.o
   --   -L/builddir/build/BUILD/zlib-ada/
   --   -L/usr/lib/gcc/aarch64-redhat-linux/10/adalib/
   --   -static
   --   -lgnat
--  END Object file/option list   

end zlib_adamain;
